<mat-accordion>
  <mat-expansion-panel [expanded]="true" class="mb-1">
    <mat-expansion-panel-header collapsedHeight="inherit" expandedHeight="inherit" class="card-header py-2 px-3">
      <mat-panel-title><h6>Contact List</h6></mat-panel-title>
    </mat-expansion-panel-header>
    <dx-data-grid #grid id="grid" [dataSource]="contactList" [wordWrapEnabled]="true" [disabled]="disabled"
                  [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                  (onInitNewRow)="onInitContactDetailNewRow($event)"
                  (onEditingStart)="onContactDetailEditingStart($event)"
                  (onRowInserted)="onContactDetailSaved($event)"
                  (onRowUpdated)="onContactDetailSaved($event)">
      <dxo-sorting mode="multiple"></dxo-sorting>
      <dxo-paging [pageSize]="10"></dxo-paging>
      <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[10, 25, 50, 100]"></dxo-pager>
      <dxo-editing mode="row" [allowUpdating]="isEditAllowed" [allowDeleting]="isDeleteAllowed" [allowAdding]="true" [useIcons]="true"></dxo-editing>
      <dxi-column dataField="hierId" caption="Hierarchy ID" dataType="string" [allowEditing]="false" headerCellTemplate="headerTemplate">
        <dxi-validation-rule type="required"></dxi-validation-rule>
        <dxi-validation-rule type="pattern" [pattern]="hierIdPattern"
                             message="H1 must be 9-digit number."></dxi-validation-rule>
      </dxi-column>
      <dxi-column dataField="hierLvlCd" caption="Hierarchy Level" dataType="string" [allowEditing]="false" headerCellTemplate="headerTemplate">
        <dxi-validation-rule type="required"></dxi-validation-rule>
        <dxo-lookup [dataSource]="hierLvlList" valueExpr="value" displayExpr="description"></dxo-lookup>
      </dxi-column>
      <dxi-column dataField="roleNme" caption="Role Code" dataType="string" [allowEditing]="false" [width]="200"
                  headerCellTemplate="headerTemplate" cellTemplate="roleTemplate">
        <dxi-validation-rule type="required"></dxi-validation-rule>
        <dxo-lookup [dataSource]="roleList" valueExpr="value" displayExpr="description"></dxo-lookup>
      </dxi-column>
      <dxi-column dataField="emailAdr" caption="Email Address" dataType="string" headerCellTemplate="headerTemplate">
        <dxi-validation-rule type="required"></dxi-validation-rule>
        <dxi-validation-rule type="email"></dxi-validation-rule>
      </dxi-column>
      <dxi-column dataField="phnNbr" caption="Phone" dataType="string"></dxi-column>
      <dxi-column dataField="emailCdIds" caption="Email Notification" dataType="string" headerCellTemplate="headerTemplate"
                  cellTemplate="tagsTemplate" editCellTemplate="emailCodeTemplate">
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
      <!--<dxi-column dataField="autoRfrshCd" caption="Auto Refresh" dataType="boolean" [visible]="!isRedesign"></dxi-column>-->
      <dxi-column dataField="suprsEmail" caption="Suppress Email" dataType="boolean"></dxi-column>
      <dxi-column type="buttons">
        <dxi-button name="edit"></dxi-button>
        <dxi-button name="delete"></dxi-button>
      </dxi-column>
      <div *dxTemplate="let data of 'btnTemplate'">
        <span class="text-danger">{{ data.column.value }}</span>
      </div>
      <!--<div *dxTemplate="let data of 'refreshTemplate'">
    <button type="button" class="btn btn-sm btn-primary"
            (click)="refreshContact()">
      Refresh
    </button>
  </div>-->
      <div *dxTemplate="let header of 'headerTemplate'">
        <span class="text-danger">{{ header.column.caption }}</span>
      </div>
      <div *dxTemplate="let cell of 'roleTemplate'">
        {{ cell.key.roleNme }}
      </div>
      <div *dxTemplate="let cell of 'tagsTemplate'">
        {{ cell.key.emailCdTxt }}
      </div>
      <div *dxTemplate="let ec of 'emailCodeTemplate'">
        <dx-tag-box [items]="statusList" [value]="ec.value"
                    valueExpr="value" displayExpr="description"
                    [showSelectionControls]="true"
                    (onValueChanged)="onStatusChanged($event.value, ec)">
        </dx-tag-box>
      </div>
    </dx-data-grid>
  </mat-expansion-panel>
</mat-accordion>
